// Package storage ...
//
// Description : 各种内存数据的管理,基于接口,可自己重新实现管理实例
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2021-04-08 5:29 下午
package storage

import "git.zhangdeman.cn/zhangdeman/websocket/context"

// IConnection 连接管理接口定义
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 5:30 下午 2021/4/8
type IConnection interface {
	// Store 存储
	Store(ctx *context.WSContext)
	// Del 移除
	Del(ctx *context.WSContext, message string)
	// GetCtxList 获取连接列表
	GetCtxList(cidList ...string) []*context.WSContext
	// Clear 清空连接
	Clear(message string)
}
